"""empty message

Revision ID: e16c64f7b42b
Revises: 0cc8c37a4786
Create Date: 2024-06-27 21:47:55.503334

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'e16c64f7b42b'
down_revision = '0cc8c37a4786'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('group',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('study_coach_id', sa.Integer(), nullable=True),
    sa.Column('monday_teacher_id', sa.Integer(), nullable=True),
    sa.Column('tuesday_teacher_id', sa.Integer(), nullable=True),
    sa.Column('wednesday_teacher_id', sa.Integer(), nullable=True),
    sa.Column('thursday_teacher_id', sa.Integer(), nullable=True),
    sa.Column('friday_teacher_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['friday_teacher_id'], ['user.id'], name=op.f('fk_group_friday_teacher_id_user')),
    sa.ForeignKeyConstraint(['monday_teacher_id'], ['user.id'], name=op.f('fk_group_monday_teacher_id_user')),
    sa.ForeignKeyConstraint(['study_coach_id'], ['user.id'], name=op.f('fk_group_study_coach_id_user')),
    sa.ForeignKeyConstraint(['thursday_teacher_id'], ['user.id'], name=op.f('fk_group_thursday_teacher_id_user')),
    sa.ForeignKeyConstraint(['tuesday_teacher_id'], ['user.id'], name=op.f('fk_group_tuesday_teacher_id_user')),
    sa.ForeignKeyConstraint(['wednesday_teacher_id'], ['user.id'], name=op.f('fk_group_wednesday_teacher_id_user')),
    sa.PrimaryKeyConstraint('id', name=op.f('pk_group'))
    )
    op.add_column('user', sa.Column('group_id', sa.Integer(), nullable=True))
    op.execute('insert into "group"(study_coach_id,name) select distinct counselor_id, (select short_name from "user" c where c.id=u.counselor_id) from "user" u where counselor_id is not null and is_active=true and is_hidden=false')
    op.execute('update "user" u set group_id=(select id from "group" where study_coach_id=u.counselor_id) where counselor_id is not null')
    op.drop_constraint('fk_user_counselor_id_user', 'user', type_='foreignkey')
    op.create_foreign_key(op.f('fk_user_group_id_group'), 'user', 'group', ['group_id'], ['id'], ondelete='SET NULL', use_alter=True)
    # op.drop_column('user', 'location')
    # op.drop_column('user', 'counselor_id')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    # op.add_column('user', sa.Column('counselor_id', sa.INTEGER(), autoincrement=False, nullable=True))
    # op.add_column('user', sa.Column('location', sa.VARCHAR(), server_default=sa.text("''::character varying"), autoincrement=False, nullable=False))
    op.drop_constraint(op.f('fk_user_group_id_group'), 'user', type_='foreignkey')
    op.create_foreign_key('fk_user_counselor_id_user', 'user', 'user', ['counselor_id'], ['id'])
    op.drop_column('user', 'group_id')
    op.drop_table('group')
    # ### end Alembic commands ###
